unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, IniFiles,
  ComCtrls, StdCtrls, Db, Grids, DBGrids, DBTables, AccessDSNCreateUnit;

type
  TMainForm = class(TForm)
    btnAdd: TButton;
    Edit1: TEdit;
    btnConfigure: TButton;
    Edit2: TEdit;
    btnRemove: TButton;
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    btnOpenTable: TButton;
    AccessDSNCreator: TAccessDSNCreator;
    procedure btnAddClick(Sender: TObject);
    procedure btnConfigureClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnOpenTableClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  AppPath : AnsiString;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
 AppPath := ExtractFilePath(ParamStr(0));
 if AppPath[Length(AppPath)] <> '\' then AppPath := AppPath + '\';
end;

procedure TMainForm.btnAddClick(Sender: TObject);
begin
  With AccessDSNCreator do
  begin
    DSNNameOrAlias := Edit1.Text;
    DSNUserDescription := Edit2.Text;
    Action := ADD_SYS_DSN;
    DatabaseFile := AppPath + 'Test.mdb';
    WorkGroupFile := AppPath; // or elsewhere if necessary
    WorkGroupFile := ''; // the .mdw file, if you need one
    UserID := '';
    Password := '';
    // you can use these options or not, as you wish
    // leaving them alone will create a DSN with the
    // default values for them anyway
    optDSNReadOnly := False;
    optExtendedAnsiSQL := 1;
    optImplitCommitSync := 'Yes';
    optMaxBufferSize := 2048;
    optMaxScanRows := 8;
    optPageTimeout := 5;
    optExclusive := False;
    optSafeTransactions := 5;
    optThreads := 3;
    optUserCommitSync := True;
    if Execute then ShowMessage('DSN Created') else Showmessage('DSN Creation Failed');
  end;
end;

procedure TMainForm.btnConfigureClick(Sender: TObject);
begin
  With AccessDSNCreator do
  begin
    DSNNameOrAlias := Edit1.Text;
    DSNUserDescription := 'GWACC Configured Datasource Name';
    Action := CONFIG_SYS_DSN;
    DatabaseFile := 'c:\windows\desktop\tstfrontline\database.mdb';
    WorkGroupFile := '';
    UserID := 'JoeSoap';    // getting these wrong may prevent you from opening
    Password := 'TestPass'; // the database. can also be used to lock someone out temporarily
    optDSNReadOnly := True;
    optExtendedAnsiSQL := 1;
    optImplitCommitSync := 'Yes';
    optMaxBufferSize := 512;
    optMaxScanRows := 10;
    optPageTimeout := 15;
    optExclusive := True;
    optThreads := 5;
    optUserCommitSync := False;
    optSafeTransactions := 8;
    if Execute then ShowMessage('DSN Configured') else Showmessage('DSN Configuration Failed');
  end;
end;

procedure TMainForm.btnRemoveClick(Sender: TObject);
begin
  Table1.Close;
  With AccessDSNCreator do
  begin
    DSNNameOrAlias := Edit1.Text;
    Action := REMOVE_SYS_DSN;
    if Execute then ShowMessage('DSN Removed') else Showmessage('DSN Removal Failed');
  end;
end;

procedure TMainForm.btnOpenTableClick(Sender: TObject);
begin
   Table1.Close;
   Table1.DatabaseName := Edit1.Text;
   Table1.TableName := 'TestDB'; // the table in the test database
   // The next step can take a few seconds and is synchronous
   // the ODBC DLLs take a while to load and untangle themselves.
   // You will be prompted for a login and password, leave these
   // fields blank if you didn't set a user id and password
   // the message box will not be shown until AFTER the table has opened
   Table1.Open;
   ShowMessage('Table Opened');
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Table1.Close;
end;

end.
